import {
  ClassType,
} from '@overflow/commons/core/type';

import {Annotation} from './annotation';

export interface AnnotatedElement {
  _addAnnotation<AnnotationType extends Annotation>(annotation: AnnotationType): void;

  isAnnotationPresent<AnnotationType extends Annotation>(annotationClass: ClassType<AnnotationType>): boolean;
  getOwnAnnotation<AnnotationType extends Annotation>(annotationClass: ClassType<AnnotationType>): AnnotationType;
  getOwnAnnotations(): Map<ClassType, Annotation>;
  getAnnotation<AnnotationType extends Annotation>(annotationClass: ClassType<AnnotationType>): AnnotationType;
  getAnnotations(): Map<ClassType, Annotation>;
}
